#ifndef HW10HELPER_H
#define HW10HELPER_H
#endif
#include <vector>
#include <utility>
#include <sstream>
#include <string>
#include <iostream>

using namespace std;
using literals = vector<pair<int, int>>;

class Helper{

public:

    void printResult(vector<pair<literals, literals>> result){

        stringstream ss;
        bool isFirstClause = true;
        ss << "[";

        for (auto clause = result.begin(); clause != result.end(); ++clause){

            if (!isFirstClause){
                ss << ", ";
            }
            else{
                isFirstClause = false;
            }

            ss << "([";
            literals positive = clause->first;
            literals negative = clause->second;
            bool isFirst = true;

            for (auto literal = positive.begin(); literal != positive.end(); ++literal){
                if (!isFirst){
                    ss << ", ";
                }
                else{
                    isFirst = false;
                }
                ss << "(";
                ss << to_string(literal->first);
                ss << ", ";
                ss << to_string(literal->second);
                ss << ")";
            }

            ss << "], ";
            ss << "[";
            isFirst = true;

            for (auto literal = negative.begin(); literal != negative.end(); ++literal){
                if (!isFirst){
                    ss << ", ";
                }
                else{
                    isFirst = false;
                }
                ss << "(";
                ss << to_string(literal->first);
                ss << ", ";
                ss << to_string(literal->second);
                ss << ")";
            }
            ss << "])";
        }
        ss << "]";
        cout << ss.str() << endl;
    }

    vector<vector<int>>* convertFormat(vector<pair<literals, literals>>* clauses, int k){

        vector<vector<int>>* result = new vector<vector<int>>();

        for (auto clause = clauses->begin(); clause != clauses->end(); ++clause){

            vector<int> temp;

            for (auto literal = (clause->first).begin(); literal != (clause->first).end(); ++literal){
                int node = literal->first;
                int color = literal->second;
                temp.push_back(color + node*k);
            }

            for (auto literal = (clause->second).begin(); literal != (clause->second).end(); ++literal){
                int node = literal->first;
                int color = literal->second;
                temp.push_back(-(color + node*k));
            }

            result->push_back(temp);
        }
        return result;
    }

    void writeCnf(const Graph& input, vector<vector<int>>* clause_list){

        int num_variables = (input.graph.size())*(input.k);
        int num_clauses = clause_list->size();

        ofstream file("formula.txt");

        if (file.is_open()){
            file << "p cnf " << to_string(num_variables) << " " << to_string(num_clauses) << endl;
            for (auto clause = clause_list->begin(); clause != clause_list->end(); ++clause){
                for (auto var = clause->begin(); var != clause->end(); ++var){
                    file << to_string(*var) << " ";
                }
                file << "0 " << endl;
           }
           file.close();
        }
    }


};
